﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration
Imports System.Windows.Forms.DataVisualization.Charting
Public Class Form1
    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        'Fetch the Statistical data from database.
        Dim query As String = "SELECT ShipCountry, DATEPART(Year, OrderDate) [Year], COUNT(OrderId) [Total]"
        query += " FROM Orders WHERE ShipCountry IN ('France', 'Germany', 'Brazil')"
        query += " GROUP BY ShipCountry, DATEPART(Year, OrderDate)"
        Dim dt As DataTable = GetData(query)

        'Get the DISTINCT Countries.
        Dim countries As List(Of String) = (From p In dt.AsEnumerable() _
                                           Select p.Field(Of String)("ShipCountry")).Distinct().ToList()

        'Remove the Default Series.
        If Chart1.Series.Count() = 1 Then
            Chart1.Series.Remove(Chart1.Series(0))
        End If

        'Loop through the Countries.
        For Each country As String In countries

            'Get the Year for each Country.
            Dim x As Integer() = (From p In dt.AsEnumerable() _
                                  Where p.Field(Of String)("ShipCountry") = country _
                                  Order By p.Field(Of Integer)("Year") _
                                  Select p.Field(Of Integer)("Year")).ToArray()

            'Get the Total of Orders for each Country.
            Dim y As Integer() = (From p In dt.AsEnumerable() _
                                  Where p.Field(Of String)("ShipCountry") = country _
                                  Order By p.Field(Of Integer)("Year") _
                                  Select p.Field(Of Integer)("Total")).ToArray()

            'Add Series to the Chart.
            Chart1.Series.Add(New Series(country))
            Chart1.Series(country).IsValueShownAsLabel = True
            Chart1.Series(country).ChartType = SeriesChartType.StackedColumn
            Chart1.Series(country).Points.DataBindXY(x, y)
        Next

        Chart1.Legends(0).Enabled = True
    End Sub

    Private Shared Function GetData(ByVal query As String) As DataTable
        Dim constr As String = "Data Source=.\SQL2005;Initial Catalog=Northwind;User ID=sa;Password=pass@123"
        Using con As SqlConnection = New SqlConnection(constr)
            Using sda As SqlDataAdapter = New SqlDataAdapter(query, con)
                Dim dt As DataTable = New DataTable()
                sda.Fill(dt)
                Return dt
            End Using
        End Using
    End Function
End Class
